Crypto::Bcrypt::Password - Crystal 0.35.1

# class Crypto::Bcrypt::Password

- Crypto::Bcrypt::Password
- Reference
- Object

##
Overview

Generate, read and verify `Crypto::Bcrypt` hashes.

    require "crypto/bcrypt/password"

    password = Crypto::Bcrypt::Password.create("super secret", cost: 10)
    # => $2a$10$rI4xRiuAN2fyiKwynO6PPuorfuoM4L2PVv6hlnVJEmNLjqcibAfHq

    password.verify("wrong secret") # => false
    password.verify("super secret") # => true

See `Crypto::Bcrypt` for hints to select the cost when generating hashes.

##
Defined in:

##
Constructors

- .create(password, cost = DEFAULT_COST) : self

  Hashes a password.

- .new(raw_hash : String)

  Loads a bcrypt hash.

##
Instance Method Summary

- #cost : Int32
- #digest : String
- #inspect(io : IO) : Nil

  Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.

- #salt : String
- #to_s(io : IO) : Nil

  Appends a short String representation of this object which includes its class name and its object address.

- #verify(password : String) : Bool

  Verifies a password against the hash.

- #version : String

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(*values : Object) : Bool
in?(collection) : Bool in?, inspect : String
inspect(io : IO) : Nil inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(io : IO, indent : String = " ")
to_pretty_json(indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.create(password, cost = DEFAULT_COST) : self #

Hashes a password.

    require "crypto/bcrypt/password"

    password = Crypto::Bcrypt::Password.create("super secret", cost: 10)
    # => $2a$10$rI4xRiuAN2fyiKwynO6PPuorfuoM4L2PVv6hlnVJEmNLjqcibAfHq

def self.new(raw_hash : String) #

Loads a bcrypt hash.

    require "crypto/bcrypt/password"

    password = Crypto::Bcrypt::Password.new("$2a$10$X6rw/jDiLBuzHV./JjBNXe8/Po4wTL0fhdDNdAdjcKN/Fup8tGCya")
    password.version # => "2a"
    password.salt    # => "X6rw/jDiLBuzHV./JjBNXe"
    password.digest  # => "8/Po4wTL0fhdDNdAdjcKN/Fup8tGCya"

##
Instance Method Detail

def cost : Int32 #
def digest : String #
def inspect(io : IO) : Nil #
Description copied from class Reference

Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.

    class Person
      def initialize(@name : String, @age : Int32)
      end
    end

    Person.new("John", 32).inspect # => #<Person:0x10fd31f20 @name="John", @age=32>

def salt : String #
def to_s(io : IO) : Nil #
Description copied from class Reference

Appends a short String representation of this object which includes its class name and its object address.

    class Person
      def initialize(@name : String, @age : Int32)
      end
    end

    Person.new("John", 32).to_s # => #<Person:0x10a199f20>

def verify(password : String) : Bool #

Verifies a password against the hash.

    require "crypto/bcrypt/password"

    password = Crypto::Bcrypt::Password.create("super secret")
    password.verify("wrong secret") # => false
    password.verify("super secret") # => true

def version : String #